+function(){var GwdPageConstants = {TAG_NAME:"gwd-page", EXTENDS_TAG_NAME:"div", Attributes:{EXPANDED:"expanded", CENTERED:"centered", ALT_ORIENTATION_PAGE:"alt-orientation-page", PAGE_WIDTH:"data-gwd-width", PAGE_HEIGHT:"data-gwd-height"}, Events:{PAGE_PRESENTING:"pagepresenting", PAGE_ACTIVATED:"pageactivated", PAGE_DEACTIVATED:"pagedeactivated"}, PLAY_ANIMATION:"gwd-play-animation", INACTIVE:"gwd-inactive", COMPONENT_TAG_PREFIX:"gwd-"};
var DomUtil = {CLASS_NAME_SELECTOR_PREFIX_:".", REFLOW_ATTRIBUTE_NAME_:"gwd-reflow", NodeType:{ELEMENT:1, ATTRIBUTE:2, TEXT:3, CDATA_SECTION:4, ENTITY_REFERENCE:5, ENTITY:6, PROCESSING_INSTRUCTION:7, COMMENT:8, DOCUMENT:9, DOCUMENT_TYPE:10, DOCUMENT_FRAGMENT:11, NOTATION:12}, selectByClassName:function(root, className) {
  return root.querySelector(DomUtil.CLASS_NAME_SELECTOR_PREFIX_ + className);
}, contains:function(parent, descendant) {
  if (parent.contains && descendant.nodeType == DomUtil.NodeType.ELEMENT) {
    return parent == descendant || parent.contains(descendant);
  }
  if ("undefined" != typeof parent.compareDocumentPosition) {
    return parent == descendant || Boolean(parent.compareDocumentPosition(descendant) & 16);
  }
  for (;descendant && parent != descendant;) {
    descendant = descendant.parentNode;
  }
  return descendant == parent;
}, maybeLoadElement:function(element) {
  if ("function" == typeof element.gwdLoad && "function" == typeof element.gwdIsLoaded && !element.gwdIsLoaded()) {
    var wrapperPage = DomUtil.closest(element, DomUtil.isGwdPage_), wrapperPageImplementsIsLoaded = wrapperPage && "function" == typeof wrapperPage.gwdIsLoaded;
    (!wrapperPage || wrapperPageImplementsIsLoaded && wrapperPage.gwdIsLoaded()) && element.gwdLoad();
  }
}, maybeActivateElement:function(element) {
  if (null == element.gwdActivate || "function" == typeof element.gwdActivate) {
    if (null == element.gwdIsActive || !element.gwdIsActive()) {
      var wrapperPage = DomUtil.closest(element, DomUtil.isGwdPage_), wrapperPageImplementsIsActive = wrapperPage && null != wrapperPage.gwdIsActive && "function" == typeof wrapperPage.gwdIsActive;
      null == wrapperPage && element.gwdActivate();
      wrapperPageImplementsIsActive && wrapperPage.gwdIsActive() && element.gwdActivate();
    }
  }
}, isGwdPage_:function(element) {
  return element.tagName.toLowerCase() == GwdPageConstants.TAG_NAME || element.getAttribute("is") == GwdPageConstants.TAG_NAME;
}, closest:function(element, matcher) {
  if (matcher(element)) {
    return element;
  }
  for (;element && element.nodeType != DomUtil.NodeType.DOCUMENT;) {
    if ((element = element.parentElement) && matcher(element)) {
      return element;
    }
  }
  return null;
}, isAttachedToDom:function(element) {
  return !(element.ownerDocument.compareDocumentPosition(element) & Node.DOCUMENT_POSITION_DISCONNECTED);
}, createElement:function(tagName) {
  return document.createElement(tagName);
}, ancestors:function(child) {
  for (var ancestors = [], node = child;node;node = node.parentNode) {
    ancestors.unshift(node);
  }
  return ancestors;
}, commonAncestor:function(node1, node2) {
  for (var ancestors1 = DomUtil.ancestors(node1), ancestors2 = DomUtil.ancestors(node2), i = 0, a1 = ancestors1[0], a2 = ancestors2[0], commonAncestor = null;a1 && a2 && a1 == a2;) {
    commonAncestor = a1, i++, a1 = ancestors1[i], a2 = ancestors2[i];
  }
  return commonAncestor;
}, reflow:function(element) {
  element.setAttribute(DomUtil.REFLOW_ATTRIBUTE_NAME_, element.offsetWidth);
}, getIntegerAttribute:function(element, name, defaultValue) {
  var value = parseInt(element.getAttribute(name), 10);
  isNaN(value) && (value = defaultValue);
  return value;
}, getFloatAttribute:function(element, name, defaultValue) {
  var value = parseFloat(element.getAttribute(name));
  isFinite(value) || (value = defaultValue);
  return value;
}, getStringAttribute:function(element, name, defaultValue) {
  return element.hasAttribute(name) ? element.getAttribute(name) : defaultValue;
}, getBooleanAttribute:function(element, name, defaultValue) {
  switch(element.getAttribute(name)) {
    case "true":
      return !0;
    case "false":
      return !1;
    default:
      return defaultValue;
  }
}, setAttributeIfDifferent:function(element, name, value) {
  return value != element.getAttribute(name) ? (element.setAttribute(name, value), !0) : !1;
}, copyAttribute:function(sourceEl, sourceName, destEl, opt_destName) {
  opt_destName = opt_destName || sourceName;
  if (sourceEl.hasAttribute(sourceName)) {
    var value = sourceEl.getAttribute(sourceName);
    destEl.setAttribute(opt_destName, value);
  } else {
    destEl.removeAttribute(opt_destName);
  }
}};
var DebugUtil = {assert:function(condition, opt_message) {
  if (!condition) {
    var error = Error(opt_message || "assertion failed");
    console.error(error);
    throw error;
  }
}, raise:function(error) {
  console.error(error);
  throw error;
}, log:function(var_args) {
  "function" == typeof console.trace ? console.trace.apply(console, arguments) : console.log.apply(console, arguments);
}, error:function(var_args) {
  console.error.apply(console, arguments);
}};
var GWDGalleryConstants = {Animate:{NONE:"none", SLIDE:"slide"}, Direction:{BACKWARDS:"backwards", FORWARDS:"forwards", LEFT:"left", RIGHT:"right"}, Events:{ALL_FRAMES_LOADED:"allframesloaded", ALL_FRAMES_VIEWED:"allframesviewed", AUTOPLAY_ENDED:"autoplayended", FIRST_INTERACTION:"firstinteraction", FRAME_ACTIVATED:"frameactivated", FRAME_AUTOPLAYED:"frameautoplayed", FRAME_EXIT:"frameexit", FRAME_SHOWN:"frameshown", FRAME_TAP:"frametap", REACH_LEFT_END:"reachleftend", FRAME_MOUSE_OVER:"framemouseover", 
FRAME_MOUSE_OUT:"framemouseout", REACH_RIGHT_END:"reachrightend"}, Attributes:{AUTOPLAY:"autoplay", AUTOPLAY_DURATION:"autoplay-duration", AUTOPLAY_STEP_DURATION:"autoplay-step-duration", FRAME_HEIGHT:"frame-height", FRAME_WIDTH:"frame-width", HAS_NAVIGATION:"has-navigation", IMAGES:"images", NAVIGATION_HIGHLIGHT:"navigation-highlight", NAVIGATION_THUMBNAILS:"navigation-thumbnails", SCALING:"scaling", START_FRAME:"start-frame", TRANSITION_DURATION:"transition-duration"}};
var GwdSwipeGalleryConstants = {SWIPE_Y:"y", TAG_NAME:"gwd-swipegallery", NAV_SPACE_PX:36, Attributes:{AUTOPLAY:"autoplay", AUTOPLAY_DURATION:"autoplay-duration", AUTOPLAY_STEP_INTERVAL:"autoplay-step-interval", DISABLE_GESTURE:"disable-gesture", EXIT_URLS:"exit-urls", FRAME_HEIGHT:"frame-height", FRAME_SNAP_INTERVAL:"frame-snap-interval", FRAME_WIDTH:"frame-width", HAS_NAVIGATION:"has-navigation", IMAGES:"images", FRAME_OFFSET:"offset", NAVIGATION_HIGHLIGHT:"navigation-highlight", NAVIGATION_THUMBNAILS:"navigation-thumbnails", 
NUM_FRAMES_TO_DISPLAY:"num-frames-to-display", SCALING:"scaling", START_FRAME:"start-frame", SWIPE_AXIS:"swipe-axis", SWIPE_THRESHOLD_RATIO:"swipe-threshold-ratio", SWIPE_COMMITTED_THRESHOLD_RATIO:"swipe-committed-threshold-ratio", TRANSITION_DURATION:"transition-duration"}, ClassName:{HAS_NAVIGATION:"has-navigation", MATTE:"matte"}, Defaults:{AUTOPLAY_DURATION:3E3, AUTOPLAY_STEP_INTERVAL:0, FRAME_HEIGHT:-1, FRAME_SNAP_INTERVAL:1, FRAME_WIDTH:-1, TRANSITION_DURATION:600, FRAME_OFFSET:0, NUM_FRAMES_TO_DISPLAY:1, 
SWIPE_THRESHOLD_RATIO:.1, SWIPE_COMMITTED_THRESHOLD_RATIO:.5}};
var GwdSwipeGalleryUtil = {isTapOutsideOfFrame:function(layoutAxis, tap, padding, frame) {
  var axis = GwdSwipeGalleryUtil.createVector(layoutAxis.y, layoutAxis.x), tapValue = GwdSwipeGalleryUtil.dotProduct(axis, tap), paddingValue = GwdSwipeGalleryUtil.dotProduct(axis, padding), framevalue = GwdSwipeGalleryUtil.dotProduct(axis, frame);
  return tapValue < paddingValue || tapValue > paddingValue + framevalue;
}, determinePerFrameOffset:function(layoutAxis, frame, margin) {
  return GwdSwipeGalleryUtil.project(GwdSwipeGalleryUtil.createVector(frame.x + margin.x, frame.y + margin.y), layoutAxis);
}, determineFullFrameVisible:function(layoutAxis, element, frame, perFrameOffset) {
  var fullFramesVisible = 1 + 2 * Math.floor((GwdSwipeGalleryUtil.dotProduct(layoutAxis, element) - GwdSwipeGalleryUtil.dotProduct(layoutAxis, frame)) / (2 * GwdSwipeGalleryUtil.dotProduct(layoutAxis, perFrameOffset)));
  if (1 > fullFramesVisible || !isFinite(fullFramesVisible)) {
    fullFramesVisible = 1;
  }
  return fullFramesVisible;
}, determineGalleryOffset:function(swipeAxis, offset, translation, padding) {
  var offsetValue = GwdSwipeGalleryUtil.dotProduct(swipeAxis, offset), translationValue = GwdSwipeGalleryUtil.dotProduct(swipeAxis, translation), paddingValue = GwdSwipeGalleryUtil.dotProduct(swipeAxis, padding);
  return offsetValue - translationValue - paddingValue;
}, dotProduct:function(vector1, vector2) {
  return vector1.x * vector2.x + vector1.y * vector2.y;
}, project:function(vector1, vector2) {
  return GwdSwipeGalleryUtil.copyAndScale(vector2, GwdSwipeGalleryUtil.dotProduct(vector1, vector2));
}, copyAndScale:function(vector, scale) {
  return GwdSwipeGalleryUtil.createVector(vector.x * scale, vector.y * scale);
}, createVector:function(x, opt_y) {
  return {x:x, y:void 0 !== opt_y ? opt_y : x};
}, determineFrameSize:function(layoutAxis, elementSize, numberOfFrames, frameSizeSetting, margin) {
  var frameSize = GwdSwipeGalleryUtil.createVector(frameSizeSetting.x == GwdSwipeGalleryConstants.Defaults.FRAME_WIDTH ? elementSize.x : frameSizeSetting.x, frameSizeSetting.y == GwdSwipeGalleryConstants.Defaults.FRAME_HEIGHT ? elementSize.y : frameSizeSetting.y), frameSizeToFitMore = GwdSwipeGalleryUtil.createVector(0);
  if (1 < numberOfFrames) {
    var count = GwdSwipeGalleryUtil.copyAndScale(layoutAxis, numberOfFrames - 1), extraMargin = GwdSwipeGalleryUtil.createVector(count.x * margin.x, count.y * margin.y), frameSizeToFitMore = GwdSwipeGalleryUtil.project(GwdSwipeGalleryUtil.createVector((elementSize.x - extraMargin.x) / numberOfFrames, (elementSize.y - extraMargin.y) / numberOfFrames), layoutAxis);
    frameSizeToFitMore.x && (frameSize.x = frameSizeToFitMore.x);
    frameSizeToFitMore.y && (frameSize.y = frameSizeToFitMore.y);
  }
  return frameSize;
}};
var goog = goog || {};
goog.global = this;
goog.isDef = function(val) {
  return void 0 !== val;
};
goog.exportPath_ = function(name, opt_object, opt_objectToExportTo) {
  var parts = name.split("."), cur = opt_objectToExportTo || goog.global;
  parts[0] in cur || !cur.execScript || cur.execScript("var " + parts[0]);
  for (var part;parts.length && (part = parts.shift());) {
    !parts.length && goog.isDef(opt_object) ? cur[part] = opt_object : cur = cur[part] ? cur[part] : cur[part] = {};
  }
};
goog.define = function(name, defaultValue) {
  var value = defaultValue;
  goog.exportPath_(name, value);
};
goog.DEBUG = !0;
goog.LOCALE = "en";
goog.TRUSTED_SITE = !0;
goog.STRICT_MODE_COMPATIBLE = !1;
goog.DISALLOW_TEST_ONLY_CODE = !goog.DEBUG;
goog.ENABLE_CHROME_APP_SAFE_SCRIPT_LOADING = !1;
goog.provide = function(name) {
  goog.constructNamespace_(name);
};
goog.constructNamespace_ = function(name, opt_obj) {
  goog.exportPath_(name, opt_obj);
};
goog.VALID_MODULE_RE_ = /^[a-zA-Z_$][a-zA-Z0-9._$]*$/;
goog.module = function(name) {
  if (!goog.isString(name) || !name || -1 == name.search(goog.VALID_MODULE_RE_)) {
    throw Error("Invalid module identifier");
  }
  if (!goog.isInModuleLoader_()) {
    throw Error("Module " + name + " has been loaded incorrectly.");
  }
  if (goog.moduleLoaderState_.moduleName) {
    throw Error("goog.module may only be called once per module.");
  }
  goog.moduleLoaderState_.moduleName = name;
};
goog.module.get = function(name) {
  return goog.module.getInternal_(name);
};
goog.module.getInternal_ = function() {
};
goog.moduleLoaderState_ = null;
goog.isInModuleLoader_ = function() {
  return null != goog.moduleLoaderState_;
};
goog.module.declareLegacyNamespace = function() {
  goog.moduleLoaderState_.declareLegacyNamespace = !0;
};
goog.setTestOnly = function(opt_message) {
  if (goog.DISALLOW_TEST_ONLY_CODE) {
    throw opt_message = opt_message || "", Error("Importing test-only code into non-debug environment" + (opt_message ? ": " + opt_message : "."));
  }
};
goog.forwardDeclare = function() {
};
goog.getObjectByName = function(name, opt_obj) {
  for (var parts = name.split("."), cur = opt_obj || goog.global, part;part = parts.shift();) {
    if (goog.isDefAndNotNull(cur[part])) {
      cur = cur[part];
    } else {
      return null;
    }
  }
  return cur;
};
goog.globalize = function(obj, opt_global) {
  var global = opt_global || goog.global, x;
  for (x in obj) {
    global[x] = obj[x];
  }
};
goog.addDependency = function(relPath, provides, requires, opt_isModule) {
  if (goog.DEPENDENCIES_ENABLED) {
    for (var provide, require, path = relPath.replace(/\\/g, "/"), deps = goog.dependencies_, i = 0;provide = provides[i];i++) {
      deps.nameToPath[provide] = path, deps.pathIsModule[path] = !!opt_isModule;
    }
    for (var j = 0;require = requires[j];j++) {
      path in deps.requires || (deps.requires[path] = {}), deps.requires[path][require] = !0;
    }
  }
};
goog.useStrictRequires = !1;
goog.ENABLE_DEBUG_LOADER = !0;
goog.logToConsole_ = function(msg) {
  goog.global.console && goog.global.console.error(msg);
};
goog.require = function() {
};
goog.basePath = "";
goog.nullFunction = function() {
};
goog.abstractMethod = function() {
  throw Error("unimplemented abstract method");
};
goog.addSingletonGetter = function(ctor) {
  ctor.getInstance = function() {
    if (ctor.instance_) {
      return ctor.instance_;
    }
    goog.DEBUG && (goog.instantiatedSingletons_[goog.instantiatedSingletons_.length] = ctor);
    return ctor.instance_ = new ctor;
  };
};
goog.instantiatedSingletons_ = [];
goog.LOAD_MODULE_USING_EVAL = !0;
goog.SEAL_MODULE_EXPORTS = goog.DEBUG;
goog.loadedModules_ = {};
goog.DEPENDENCIES_ENABLED = !1;
goog.DEPENDENCIES_ENABLED && (goog.dependencies_ = {pathIsModule:{}, nameToPath:{}, requires:{}, visited:{}, written:{}, deferred:{}}, goog.inHtmlDocument_ = function() {
  var doc = goog.global.document;
  return null != doc && "write" in doc;
}, goog.findBasePath_ = function() {
  if (goog.isDef(goog.global.CLOSURE_BASE_PATH)) {
    goog.basePath = goog.global.CLOSURE_BASE_PATH;
  } else {
    if (goog.inHtmlDocument_()) {
      for (var doc = goog.global.document, scripts = doc.getElementsByTagName("SCRIPT"), i = scripts.length - 1;0 <= i;--i) {
        var script = scripts[i], src = script.src, qmark = src.lastIndexOf("?"), l = -1 == qmark ? src.length : qmark;
        if ("base.js" == src.substr(l - 7, 7)) {
          goog.basePath = src.substr(0, l - 7);
          break;
        }
      }
    }
  }
}, goog.importScript_ = function(src, opt_sourceText) {
  var importScript = goog.global.CLOSURE_IMPORT_SCRIPT || goog.writeScriptTag_;
  importScript(src, opt_sourceText) && (goog.dependencies_.written[src] = !0);
}, goog.IS_OLD_IE_ = !(goog.global.atob || !goog.global.document || !goog.global.document.all), goog.importModule_ = function(src) {
  var bootstrap = 'goog.retrieveAndExecModule_("' + src + '");';
  goog.importScript_("", bootstrap) && (goog.dependencies_.written[src] = !0);
}, goog.queuedModules_ = [], goog.wrapModule_ = function(srcUrl, scriptText) {
  return goog.LOAD_MODULE_USING_EVAL && goog.isDef(goog.global.JSON) ? "goog.loadModule(" + goog.global.JSON.stringify(scriptText + "\n//# sourceURL=" + srcUrl + "\n") + ");" : 'goog.loadModule(function(exports) {"use strict";' + scriptText + "\n;return exports});\n//# sourceURL=" + srcUrl + "\n";
}, goog.loadQueuedModules_ = function() {
  var count = goog.queuedModules_.length;
  if (0 < count) {
    var queue = goog.queuedModules_;
    goog.queuedModules_ = [];
    for (var i = 0;i < count;i++) {
      var path = queue[i];
      goog.maybeProcessDeferredPath_(path);
    }
  }
}, goog.maybeProcessDeferredDep_ = function(name) {
  if (goog.isDeferredModule_(name) && goog.allDepsAreAvailable_(name)) {
    var path = goog.getPathFromDeps_(name);
    goog.maybeProcessDeferredPath_(goog.basePath + path);
  }
}, goog.isDeferredModule_ = function(name) {
  var path = goog.getPathFromDeps_(name);
  if (path && goog.dependencies_.pathIsModule[path]) {
    var abspath = goog.basePath + path;
    return abspath in goog.dependencies_.deferred;
  }
  return !1;
}, goog.allDepsAreAvailable_ = function(name) {
  var path = goog.getPathFromDeps_(name);
  if (path && path in goog.dependencies_.requires) {
    for (var requireName in goog.dependencies_.requires[path]) {
      if (!goog.isProvided_(requireName) && !goog.isDeferredModule_(requireName)) {
        return !1;
      }
    }
  }
  return !0;
}, goog.maybeProcessDeferredPath_ = function(abspath) {
  if (abspath in goog.dependencies_.deferred) {
    var src = goog.dependencies_.deferred[abspath];
    delete goog.dependencies_.deferred[abspath];
    goog.globalEval(src);
  }
}, goog.loadModuleFromUrl = function(url) {
  goog.retrieveAndExecModule_(url);
}, goog.loadModule = function(moduleDef) {
  var previousState = goog.moduleLoaderState_;
  try {
    goog.moduleLoaderState_ = {moduleName:void 0, declareLegacyNamespace:!1};
    var exports;
    if (goog.isFunction(moduleDef)) {
      exports = moduleDef.call(goog.global, {});
    } else {
      if (goog.isString(moduleDef)) {
        exports = goog.loadModuleFromSource_.call(goog.global, moduleDef);
      } else {
        throw Error("Invalid module definition");
      }
    }
    var moduleName = goog.moduleLoaderState_.moduleName;
    if (!goog.isString(moduleName) || !moduleName) {
      throw Error('Invalid module name "' + moduleName + '"');
    }
    goog.moduleLoaderState_.declareLegacyNamespace ? goog.constructNamespace_(moduleName, exports) : goog.SEAL_MODULE_EXPORTS && Object.seal && Object.seal(exports);
    goog.loadedModules_[moduleName] = exports;
  } finally {
    goog.moduleLoaderState_ = previousState;
  }
}, goog.loadModuleFromSource_ = function(JSCompiler_OptimizeArgumentsArray_p0) {
  var exports = {};
  eval(JSCompiler_OptimizeArgumentsArray_p0);
  return exports;
}, goog.writeScriptSrcNode_ = function(src) {
  goog.global.document.write('<script type="text/javascript" src="' + src + '">\x3c/script>');
}, goog.appendScriptSrcNode_ = function(src) {
  var doc = goog.global.document, scriptEl = doc.createElement("script");
  scriptEl.type = "text/javascript";
  scriptEl.src = src;
  scriptEl.defer = !1;
  scriptEl.async = !1;
  doc.head.appendChild(scriptEl);
}, goog.writeScriptTag_ = function(src, opt_sourceText) {
  if (goog.inHtmlDocument_()) {
    var doc = goog.global.document;
    if (!goog.ENABLE_CHROME_APP_SAFE_SCRIPT_LOADING && "complete" == doc.readyState) {
      var isDeps = /\bdeps.js$/.test(src);
      if (isDeps) {
        return !1;
      }
      throw Error('Cannot write "' + src + '" after document load');
    }
    var isOldIE = goog.IS_OLD_IE_;
    if (void 0 === opt_sourceText) {
      if (isOldIE) {
        var state = " onreadystatechange='goog.onScriptLoad_(this, " + ++goog.lastNonModuleScriptIndex_ + ")' ";
        doc.write('<script type="text/javascript" src="' + src + '"' + state + ">\x3c/script>");
      } else {
        goog.ENABLE_CHROME_APP_SAFE_SCRIPT_LOADING ? goog.appendScriptSrcNode_(src) : goog.writeScriptSrcNode_(src);
      }
    } else {
      doc.write('<script type="text/javascript">' + opt_sourceText + "\x3c/script>");
    }
    return !0;
  }
  return !1;
}, goog.lastNonModuleScriptIndex_ = 0, goog.onScriptLoad_ = function(script, scriptIndex) {
  "complete" == script.readyState && goog.lastNonModuleScriptIndex_ == scriptIndex && goog.loadQueuedModules_();
  return !0;
}, goog.writeScripts_ = function(pathToLoad) {
  function visitNode(path) {
    if (!(path in deps.written || path in deps.visited)) {
      deps.visited[path] = !0;
      if (path in deps.requires) {
        for (var requireName in deps.requires[path]) {
          if (!goog.isProvided_(requireName)) {
            if (requireName in deps.nameToPath) {
              visitNode(deps.nameToPath[requireName]);
            } else {
              throw Error("Undefined nameToPath for " + requireName);
            }
          }
        }
      }
      path in seenScript || (seenScript[path] = !0, scripts.push(path));
    }
  }
  var scripts = [], seenScript = {}, deps = goog.dependencies_;
  visitNode(pathToLoad);
  for (var i = 0;i < scripts.length;i++) {
    var path$$0 = scripts[i];
    goog.dependencies_.written[path$$0] = !0;
  }
  var moduleState = goog.moduleLoaderState_;
  goog.moduleLoaderState_ = null;
  for (i = 0;i < scripts.length;i++) {
    if (path$$0 = scripts[i]) {
      deps.pathIsModule[path$$0] ? goog.importModule_(goog.basePath + path$$0) : goog.importScript_(goog.basePath + path$$0);
    } else {
      throw goog.moduleLoaderState_ = moduleState, Error("Undefined script input");
    }
  }
  goog.moduleLoaderState_ = moduleState;
}, goog.getPathFromDeps_ = function(rule) {
  return rule in goog.dependencies_.nameToPath ? goog.dependencies_.nameToPath[rule] : null;
}, goog.findBasePath_(), goog.global.CLOSURE_NO_DEPS || goog.importScript_(goog.basePath + "deps.js"));
goog.normalizePath_ = function(path) {
  for (var components = path.split("/"), i = 0;i < components.length;) {
    "." == components[i] ? components.splice(i, 1) : i && ".." == components[i] && components[i - 1] && ".." != components[i - 1] ? components.splice(--i, 2) : i++;
  }
  return components.join("/");
};
goog.loadFileSync_ = function(src) {
  if (goog.global.CLOSURE_LOAD_FILE_SYNC) {
    return goog.global.CLOSURE_LOAD_FILE_SYNC(src);
  }
  var xhr = new goog.global.XMLHttpRequest;
  xhr.open("get", src, !1);
  xhr.send();
  return xhr.responseText;
};
goog.retrieveAndExecModule_ = function() {
};
goog.typeOf = function(value) {
  var s = typeof value;
  if ("object" == s) {
    if (value) {
      if (value instanceof Array) {
        return "array";
      }
      if (value instanceof Object) {
        return s;
      }
      var className = Object.prototype.toString.call(value);
      if ("[object Window]" == className) {
        return "object";
      }
      if ("[object Array]" == className || "number" == typeof value.length && "undefined" != typeof value.splice && "undefined" != typeof value.propertyIsEnumerable && !value.propertyIsEnumerable("splice")) {
        return "array";
      }
      if ("[object Function]" == className || "undefined" != typeof value.call && "undefined" != typeof value.propertyIsEnumerable && !value.propertyIsEnumerable("call")) {
        return "function";
      }
    } else {
      return "null";
    }
  } else {
    if ("function" == s && "undefined" == typeof value.call) {
      return "object";
    }
  }
  return s;
};
goog.isNull = function(val) {
  return null === val;
};
goog.isDefAndNotNull = function(val) {
  return null != val;
};
goog.isArray = function(val) {
  return "array" == goog.typeOf(val);
};
goog.isArrayLike = function(val) {
  var type = goog.typeOf(val);
  return "array" == type || "object" == type && "number" == typeof val.length;
};
goog.isDateLike = function(val) {
  return goog.isObject(val) && "function" == typeof val.getFullYear;
};
goog.isString = function(val) {
  return "string" == typeof val;
};
goog.isBoolean = function(val) {
  return "boolean" == typeof val;
};
goog.isNumber = function(val) {
  return "number" == typeof val;
};
goog.isFunction = function(val) {
  return "function" == goog.typeOf(val);
};
goog.isObject = function(val) {
  var type = typeof val;
  return "object" == type && null != val || "function" == type;
};
goog.getUid = function(obj) {
  return obj[goog.UID_PROPERTY_] || (obj[goog.UID_PROPERTY_] = ++goog.uidCounter_);
};
goog.hasUid = function(obj) {
  return !!obj[goog.UID_PROPERTY_];
};
goog.removeUid = function(obj) {
  null !== obj && "removeAttribute" in obj && obj.removeAttribute(goog.UID_PROPERTY_);
  try {
    delete obj[goog.UID_PROPERTY_];
  } catch (ex) {
  }
};
goog.UID_PROPERTY_ = "closure_uid_" + (1E9 * Math.random() >>> 0);
goog.uidCounter_ = 0;
goog.getHashCode = goog.getUid;
goog.removeHashCode = goog.removeUid;
goog.cloneObject = function(obj) {
  var type = goog.typeOf(obj);
  if ("object" == type || "array" == type) {
    if (obj.clone) {
      return obj.clone();
    }
    var clone = "array" == type ? [] : {}, key;
    for (key in obj) {
      clone[key] = goog.cloneObject(obj[key]);
    }
    return clone;
  }
  return obj;
};
goog.bindNative_ = function(fn, selfObj, var_args) {
  return fn.call.apply(fn.bind, arguments);
};
goog.bindJs_ = function(fn, selfObj, var_args) {
  if (!fn) {
    throw Error();
  }
  if (2 < arguments.length) {
    var boundArgs = Array.prototype.slice.call(arguments, 2);
    return function() {
      var newArgs = Array.prototype.slice.call(arguments);
      Array.prototype.unshift.apply(newArgs, boundArgs);
      return fn.apply(selfObj, newArgs);
    };
  }
  return function() {
    return fn.apply(selfObj, arguments);
  };
};
goog.bind = function(fn, selfObj, var_args) {
  goog.bind = Function.prototype.bind && -1 != Function.prototype.bind.toString().indexOf("native code") ? goog.bindNative_ : goog.bindJs_;
  return goog.bind.apply(null, arguments);
};
goog.partial = function(fn, var_args) {
  var args = Array.prototype.slice.call(arguments, 1);
  return function() {
    var newArgs = args.slice();
    newArgs.push.apply(newArgs, arguments);
    return fn.apply(this, newArgs);
  };
};
goog.mixin = function(target, source) {
  for (var x in source) {
    target[x] = source[x];
  }
};
goog.now = goog.TRUSTED_SITE && Date.now || function() {
  return +new Date;
};
goog.globalEval = function(script) {
  if (goog.global.execScript) {
    goog.global.execScript(script, "JavaScript");
  } else {
    if (goog.global.eval) {
      if (null == goog.evalWorksForGlobals_) {
        if (goog.global.eval("var _evalTest_ = 1;"), "undefined" != typeof goog.global._evalTest_) {
          try {
            delete goog.global._evalTest_;
          } catch (ignore) {
          }
          goog.evalWorksForGlobals_ = !0;
        } else {
          goog.evalWorksForGlobals_ = !1;
        }
      }
      if (goog.evalWorksForGlobals_) {
        goog.global.eval(script);
      } else {
        var doc = goog.global.document, scriptElt = doc.createElement("SCRIPT");
        scriptElt.type = "text/javascript";
        scriptElt.defer = !1;
        scriptElt.appendChild(doc.createTextNode(script));
        doc.body.appendChild(scriptElt);
        doc.body.removeChild(scriptElt);
      }
    } else {
      throw Error("goog.globalEval not available");
    }
  }
};
goog.evalWorksForGlobals_ = null;
goog.getCssName = function(className, opt_modifier) {
  var getMapping = function(cssName) {
    return goog.cssNameMapping_[cssName] || cssName;
  }, renameByParts = function(cssName) {
    for (var parts = cssName.split("-"), mapped = [], i = 0;i < parts.length;i++) {
      mapped.push(getMapping(parts[i]));
    }
    return mapped.join("-");
  }, rename;
  rename = goog.cssNameMapping_ ? "BY_WHOLE" == goog.cssNameMappingStyle_ ? getMapping : renameByParts : function(a) {
    return a;
  };
  return opt_modifier ? className + "-" + rename(opt_modifier) : rename(className);
};
goog.setCssNameMapping = function(mapping, opt_style) {
  goog.cssNameMapping_ = mapping;
  goog.cssNameMappingStyle_ = opt_style;
};
goog.getMsg = function(str, opt_values) {
  opt_values && (str = str.replace(/\{\$([^}]+)}/g, function(match, key) {
    return null != opt_values && key in opt_values ? opt_values[key] : match;
  }));
  return str;
};
goog.getMsgWithFallback = function(a) {
  return a;
};
goog.exportSymbol = function(publicPath, object, opt_objectToExportTo) {
  goog.exportPath_(publicPath, object, opt_objectToExportTo);
};
goog.exportProperty = function(object, publicName, symbol) {
  object[publicName] = symbol;
};
goog.inherits = function(childCtor, parentCtor) {
  function tempCtor() {
  }
  tempCtor.prototype = parentCtor.prototype;
  childCtor.superClass_ = parentCtor.prototype;
  childCtor.prototype = new tempCtor;
  childCtor.prototype.constructor = childCtor;
  childCtor.base = function(me, methodName, var_args) {
    for (var args = Array(arguments.length - 2), i = 2;i < arguments.length;i++) {
      args[i - 2] = arguments[i];
    }
    return parentCtor.prototype[methodName].apply(me, args);
  };
};
goog.base = function(me, opt_methodName, var_args) {
  var caller = arguments.callee.caller;
  if (goog.STRICT_MODE_COMPATIBLE || goog.DEBUG && !caller) {
    throw Error("arguments.caller not defined.  goog.base() cannot be used with strict mode code. See http://www.ecma-international.org/ecma-262/5.1/#sec-C");
  }
  if (caller.superClass_) {
    for (var ctorArgs = Array(arguments.length - 1), i = 1;i < arguments.length;i++) {
      ctorArgs[i - 1] = arguments[i];
    }
    return caller.superClass_.constructor.apply(me, ctorArgs);
  }
  for (var args = Array(arguments.length - 2), i = 2;i < arguments.length;i++) {
    args[i - 2] = arguments[i];
  }
  for (var foundCaller = !1, ctor = me.constructor;ctor;ctor = ctor.superClass_ && ctor.superClass_.constructor) {
    if (ctor.prototype[opt_methodName] === caller) {
      foundCaller = !0;
    } else {
      if (foundCaller) {
        return ctor.prototype[opt_methodName].apply(me, args);
      }
    }
  }
  if (me[opt_methodName] === caller) {
    return me.constructor.prototype[opt_methodName].apply(me, args);
  }
  throw Error("goog.base called from a method of one name to a method of a different name");
};
goog.scope = function(fn) {
  fn.call(goog.global);
};
goog.defineClass = function(superClass, def) {
  var constructor = def.constructor, statics = def.statics;
  constructor && constructor != Object.prototype.constructor || (constructor = function() {
    throw Error("cannot instantiate an interface (no constructor defined).");
  });
  var cls = goog.defineClass.createSealingConstructor_(constructor, superClass);
  superClass && goog.inherits(cls, superClass);
  delete def.constructor;
  delete def.statics;
  goog.defineClass.applyProperties_(cls.prototype, def);
  null != statics && (statics instanceof Function ? statics(cls) : goog.defineClass.applyProperties_(cls, statics));
  return cls;
};
goog.defineClass.SEAL_CLASS_INSTANCES = goog.DEBUG;
goog.defineClass.createSealingConstructor_ = function(ctr, superClass) {
  if (goog.defineClass.SEAL_CLASS_INSTANCES && Object.seal instanceof Function) {
    if (superClass && superClass.prototype && superClass.prototype[goog.UNSEALABLE_CONSTRUCTOR_PROPERTY_]) {
      return ctr;
    }
    var wrappedCtr = function() {
      var instance = ctr.apply(this, arguments) || this;
      instance[goog.UID_PROPERTY_] = instance[goog.UID_PROPERTY_];
      this.constructor === wrappedCtr && Object.seal(instance);
      return instance;
    };
    return wrappedCtr;
  }
  return ctr;
};
goog.defineClass.OBJECT_PROTOTYPE_FIELDS_ = "constructor hasOwnProperty isPrototypeOf propertyIsEnumerable toLocaleString toString valueOf".split(" ");
goog.defineClass.applyProperties_ = function(target, source) {
  for (var key in source) {
    Object.prototype.hasOwnProperty.call(source, key) && (target[key] = source[key]);
  }
  for (var i = 0;i < goog.defineClass.OBJECT_PROTOTYPE_FIELDS_.length;i++) {
    key = goog.defineClass.OBJECT_PROTOTYPE_FIELDS_[i], Object.prototype.hasOwnProperty.call(source, key) && (target[key] = source[key]);
  }
};
goog.tagUnsealableClass = function() {
};
goog.UNSEALABLE_CONSTRUCTOR_PROPERTY_ = "goog_defineClass_legacy_unsealable";
var CssUtil = {Attributes:{TRANSITION_DURATION:"transition-duration"}, browserPrefixes_:["-ms-", "-moz-", "-webkit-", ""], applyCssWithBrowserPrefix:function(element, name, value, opt_prefixOnValue) {
  for (var propertyName, propertyValue, i = 0;i < CssUtil.browserPrefixes_.length;++i) {
    propertyName = CssUtil.browserPrefixes_[i] + name, propertyValue = (opt_prefixOnValue ? CssUtil.browserPrefixes_[i] : "") + value, element.style.setProperty(propertyName, propertyValue);
  }
}, getPropertyValue:function(element, name) {
  for (var falseyValue = null, value, i = 0;i < CssUtil.browserPrefixes_.length;++i) {
    if (value = element.style.getPropertyValue(CssUtil.browserPrefixes_[i] + name)) {
      return value;
    }
    null != value && (falseyValue = value);
  }
  return falseyValue;
}, installStyles:function(stylesString) {
  var styleSheet = null, doc = document, isIE = -1 != navigator.userAgent.indexOf("MSIE");
  if (isIE && doc.createStyleSheet) {
    styleSheet = doc.createStyleSheet(), styleSheet.cssText = stylesString;
  } else {
    var head = doc.getElementsByTagName("head")[0];
    if (!head) {
      var body = doc.getElementsByTagName("body")[0], head = doc.createElement("head");
      body.parentNode.insertBefore(head, body);
    }
    styleSheet = doc.createElement("style");
    styleSheet.innerHTML = stylesString;
    head.appendChild(styleSheet);
  }
  return styleSheet;
}, uninstallStyles:function(styleSheet) {
  var node = styleSheet.ownerNode || styleSheet.owningElement || styleSheet;
  node && node.parentNode && node.parentNode.removeChild(node);
}, isElementShown:function(el) {
  return "none" != el.style.display;
}, setElementShown:function(el, isShown) {
  el.style.display = isShown ? "" : "none";
}};
var ClockUtil = {setTimeout:function(callback, delay) {
  return setTimeout(callback, delay);
}, clearTimeout:function(timeoutId) {
  clearTimeout(timeoutId);
}, setInterval:function(callback, delay) {
  return setInterval(callback, delay);
}, clearInterval:function(intervalId) {
  clearInterval(intervalId);
}};
var EventTypes = {ABORT:"abort", ATTACHED:"attached", CAN_PLAY:"canplay", CLICK:"click", DETACHED:"detached", DRAG_END:"dragend", ERROR:"error", HOVER:"hover", HOVER_END:"hoverend", LOAD:"load", MOUSE_DOWN:"mousedown", MOUSE_MOVE:"mousemove", MOUSE_OUT:"mouseout", MOUSE_OVER:"mouseover", MOUSE_UP:"mouseup", PAGE_LOAD:"pageload", POINTER_CANCEL:"pointercancel", POINTER_DOWN:"pointerdown", POINTER_MOVE:"pointermove", POINTER_OUT:"pointerout", POINTER_OVER:"pointerover", POINTER_UP:"pointerup", READY:"ready", 
RESIZE:"resize", ROTATE_TO_PORTRAIT:"rotatetoportrait", ROTATE_TO_LANDSCAPE:"rotatetolandscape", SHAKE:"shake", SUBMIT:"submit", TAP:"tap", TILT:"tilt", TOUCH_END:"touchend", TOUCH_MOVE:"touchmove", TOUCH_START:"touchstart", TRACK:"track", TRACK_END:"trackend", TRACK_START:"trackstart", SWIPE_LEFT:"swipeleft", SWIPE_RIGHT:"swiperight", SWIPE_UP:"swipeup", SWIPE_DOWN:"swipedown", TRANSITION_END:"transitionend", WEB_COMPONENTS_READY:"WebComponentsReady", WEBGL_CONTEXT_LOST:"webglcontextlost", WEBGL_CONTEXT_RESTORED:"webglcontextrestored", 
WEBKIT_TRANSITION_END:"webkitTransitionEnd"}, EventUtil = {dispatch:function(eventName, source, opt_detail) {
  var event;
  opt_detail ? (event = document.createEvent("CustomEvent"), event.initCustomEvent(eventName, !0, !0, opt_detail)) : (event = document.createEvent("Event"), event.initEvent(eventName, !0, !0));
  source.dispatchEvent(event);
  return event;
}, dispatchAsync:function(eventName, source, opt_detail, opt_callback) {
  ClockUtil.setTimeout(function() {
    var evt = EventUtil.dispatch(eventName, source, opt_detail);
    opt_callback && opt_callback(evt);
  }, 0);
}, listenOnce:function(source, eventName, handler) {
  var listenOnceHandler = function(e) {
    source.removeEventListener(eventName, listenOnceHandler);
    handler(e);
  };
  source.addEventListener(eventName, listenOnceHandler);
}, BETWEEN_MILLI_AND_MICRO_TIME_STAMPS_:5E12, getNormalizedEventTimeStamp:function(event) {
  var timeStamp = event.timeStamp;
  return timeStamp < EventUtil.BETWEEN_MILLI_AND_MICRO_TIME_STAMPS_ ? timeStamp : timeStamp / 1E3;
}};
var FileUtil = {getFullPath:function(src) {
  src = src.trim();
  return window.Enabler ? Enabler.getUrl(src) : src;
}};
var GwdGestureConstants = {TAP_THRESHOLD:10, TAG_NAME:"gwd-gesture", DEFAULT_SWIPE_VELOCITY:.5, DEFAULT_SWIPE_DISTANCE:.1, TouchAction:{NONE:"none", AUTO:"auto", PAN_X:"pan-x", PAN_Y:"pan-y"}, Attributes:{TOUCH_ACTION:"touch-action", SWIPE_VELOCITY:"swipe-velocity", SWIPE_DISTANCE:"swipe-distance"}};
var GwdImageConstants = {NONE_SCALING_BACKGROUND_SIZE_:"auto", TAG_NAME:"gwd-image", BLANK_TRANSPARENT_GIF:"data:image/gif;base64,R0lGODlhAQABAPAAAAAAAAAAACH5BAEAAAAALAAAAAABAAEAAAICRAEAOw==", EXTENDS_TAG_NAME:"img", Attributes:{SCALING:"scaling", SOURCE:"source", SRC:"src"}, States:{INIT:0, PENDING:1, LOADED:2, ERROR:3}, ScalingModes:{CONTAIN:"contain", COVER:"cover", NONE:"none", STRETCH:"stretch"}};
GwdImageConstants.Defaults = {SCALING:GwdImageConstants.ScalingModes.STRETCH};
GwdImageConstants.StyleClasses = {SCALED_PROPORTIONALLY:"scaled-proportionally"};
var GalleryUtil = {FRAME_CLASS_NAME_:"frame", GESTURE_CLASS_NAME_:"gesture", Autoplayer:function(gallery, delayFirst) {
  this.gallery_ = gallery;
  this.playIntervalId_ = null;
  this.playCurrentFirst_ = delayFirst;
  this.goingToFrame_ = !1;
}};
GalleryUtil.Autoplayer.prototype.play = function(duration, opt_direction, opt_stepInterval) {
  if (this.gallery_.frameCount && !this.isPlaying()) {
    var direction = opt_direction || GWDGalleryConstants.Direction.FORWARDS;
    DebugUtil.assert(direction == GWDGalleryConstants.Direction.FORWARDS || direction == GWDGalleryConstants.Direction.BACKWARDS, "Unexpected rotation direction: " + direction);
    var stepCount, stepInterval;
    opt_stepInterval ? (stepCount = Math.floor(duration / opt_stepInterval), stepInterval = opt_stepInterval) : (stepCount = this.gallery_.frameCount, stepInterval = duration / stepCount);
    for (var targetIndices = [], baseFrameIndex = this.gallery_.currentIndex - 1, nextIndex = baseFrameIndex, i = 0;i < stepCount;i++) {
      if (0 < i || !this.playCurrentFirst_) {
        nextIndex = GalleryUtil.getNextFrame(nextIndex, direction, this.gallery_.frameCount);
      }
      targetIndices.push(nextIndex);
    }
    var stepOneFrame = function() {
      if (targetIndices.length) {
        var targetIndex = targetIndices.shift();
        this.goToFrame_(targetIndex + 1);
        GalleryUtil.dispatchEventWithIndex(this.gallery_, GWDGalleryConstants.Events.FRAME_AUTOPLAYED, targetIndex + 1);
      } else {
        this.stop(!0), this.gallery_.goToFrame(baseFrameIndex + 1);
      }
    }.bind(this);
    this.playIntervalId_ = ClockUtil.setInterval(stepOneFrame, stepInterval);
    setTimeout(stepOneFrame);
  }
};
GalleryUtil.Autoplayer.prototype.goToFrame_ = function(frameIndex) {
  DebugUtil.assert(!this.goingToFrame_);
  this.goingToFrame_ = !0;
  this.gallery_.goToFrame(frameIndex);
  DebugUtil.assert(this.goingToFrame_);
  this.goingToFrame_ = !1;
};
GalleryUtil.Autoplayer.prototype.stop = function(opt_completed) {
  !this.goingToFrame_ && this.playIntervalId_ && (ClockUtil.clearInterval(this.playIntervalId_), EventUtil.dispatchAsync(GWDGalleryConstants.Events.AUTOPLAY_ENDED, this.gallery_, {completed:!!opt_completed}), this.playIntervalId_ = null);
};
GalleryUtil.Autoplayer.prototype.isPlaying = function() {
  return null != this.playIntervalId_;
};
GalleryUtil.isGallery = function(element) {
  if (!element) {
    return !1;
  }
  for (var expectedProperties = "currentIndex frameCount frameSnapInterval getFrame goToFrame goForwards goBackwards rotateOnce".split(" "), i = 0;i < expectedProperties.length;++i) {
    if (!(expectedProperties[i] in element)) {
      return !1;
    }
  }
  return !0;
};
GalleryUtil.prepareOneFrame_ = function(imageUrl) {
  var image = document.createElement("img", GwdImageConstants.TAG_NAME);
  image.setAttribute(GwdImageConstants.Attributes.SOURCE, imageUrl);
  return image;
};
GalleryUtil.createFrames = function(imagesString) {
  var frames = [];
  if (imagesString) {
    for (var images = imagesString.split(","), i = 0;i < images.length;++i) {
      /\S/.test(images[i]) && frames.push(GalleryUtil.prepareOneFrame_(FileUtil.getFullPath(images[i])));
    }
  }
  return frames;
};
GalleryUtil.createLoadingPage = function(frames, opt_perFrameOperation) {
  for (var loadingPage = document.createElement("div", GwdPageConstants.TAG_NAME), frame, i = 0;i < frames.length;++i) {
    frame = frames[i], CssUtil.applyCssWithBrowserPrefix(frame, "user-select", "none"), frame.classList.add(GalleryUtil.FRAME_CLASS_NAME_), opt_perFrameOperation && opt_perFrameOperation(frame), loadingPage.appendChild(frame);
  }
  EventUtil.listenOnce(loadingPage, EventTypes.ATTACHED, loadingPage.gwdLoad.bind(loadingPage));
  return loadingPage;
};
GalleryUtil.createGestureElement = function() {
  var gesture = document.createElement(GwdGestureConstants.TAG_NAME);
  gesture.className = GalleryUtil.GESTURE_CLASS_NAME_;
  return gesture;
};
GalleryUtil.extractFrames = function(frameList) {
  for (var frames = [], i = 0, length = frameList.length;i < length;i++) {
    var frame = frameList[i];
    frame.nodeType == Node.ELEMENT_NODE && frames.push(frame);
  }
  return frames;
};
GalleryUtil.applyScaling = function(frames, scaling) {
  for (var i = 0, l = frames.length;i < l;i++) {
    var frame = frames[i];
    "img" == frame.tagName.toLowerCase() && frame.getAttribute("is") == GwdImageConstants.TAG_NAME && (null != scaling ? frame.setAttribute(GwdImageConstants.Attributes.SCALING, scaling) : frame.removeAttribute(GwdImageConstants.Attributes.SCALING));
  }
};
GalleryUtil.dispatchEventWithIndex = function(gallery, eventName, opt_index) {
  var index = opt_index || gallery.currentIndex;
  EventUtil.dispatch(eventName, gallery, {id:index});
};
GalleryUtil.dispatchEventsOnTransitionEnd = function(gallery, events) {
  for (var length = events.length, eventNames = events.splice(0, length), eventName, i = 0;i < length;i++) {
    eventName = eventNames[i], eventName == GWDGalleryConstants.Events.FRAME_SHOWN ? GalleryUtil.dispatchEventWithIndex(gallery, eventName) : EventUtil.dispatch(eventName, gallery);
  }
};
GalleryUtil.getFrameIncrement_ = function(direction, distance) {
  var moveBackwards = direction == GWDGalleryConstants.Direction.LEFT || direction == GWDGalleryConstants.Direction.BACKWARDS;
  return moveBackwards ? -distance : distance;
};
GalleryUtil.findProperFrame = function(index, frameCount) {
  return (index % frameCount + frameCount) % frameCount;
};
GalleryUtil.getNextFrame = function(index, direction, frameCount, opt_distance) {
  var distance = opt_distance || 1;
  return GalleryUtil.findProperFrame(index + GalleryUtil.getFrameIncrement_(direction, distance), frameCount);
};
var GWDGalleryElementImpl = function() {
};
goog.inherits(GWDGalleryElementImpl, HTMLElement);
GWDGalleryElementImpl.prototype.createdCallback = function() {
  this.frames_ = [];
  this.frameIndex_ = null;
  this.frameCount_ = 0;
  this.frameSnapInterval_ = 1;
  this.autoplayer_ = new GalleryUtil.Autoplayer(this, !0);
  Object.defineProperty(this, "currentIndex", {enumerable:!0, get:this.getCurrentIndex_.bind(this)});
  Object.defineProperty(this, "frameSnapInterval", {enumerable:!0, get:this.getFrameSnapInterval_.bind(this)});
  Object.defineProperty(this, "frameCount", {enumerable:!0, get:this.getFrameCount_.bind(this)});
};
GWDGalleryElementImpl.prototype.attributeChangedCallback = function() {
};
GWDGalleryElementImpl.prototype.getFrame = function(frameNumber) {
  if (0 != this.frameCount_) {
    return this.frames_[frameNumber - 1];
  }
};
GWDGalleryElementImpl.prototype.gwdLoad = function() {
};
GWDGalleryElementImpl.prototype.gwdIsLoaded = function() {
  return !0;
};
GWDGalleryElementImpl.prototype.goToFrame = function(targetFrameNumber, opt_animate) {
  this.stopRotation();
  0 != this.frameCount_ && (targetFrameNumber > this.frameCount_ ? targetFrameNumber = this.frameCount_ : 1 > targetFrameNumber && (targetFrameNumber = 1), this.goToFrameImpl_(targetFrameNumber, opt_animate));
};
GWDGalleryElementImpl.prototype.goToFrameImpl_ = function(targetFrameNumber) {
  this.frameIndex_ = targetFrameNumber - 1;
};
GWDGalleryElementImpl.prototype.goBackwardsForwardsImpl_ = function(direction, opt_animate, opt_wrap) {
  if (null != this.frameIndex_) {
    var wrap = null != opt_wrap ? opt_wrap : !0, paddedFrameCount = this.frameSnapInterval_ * Math.ceil(this.frameCount_ / this.frameSnapInterval_), newIndex = GalleryUtil.getNextFrame(this.frameIndex_, direction, paddedFrameCount, this.frameSnapInterval_), animate = opt_animate || GWDGalleryConstants.Animate.SLIDE;
    !wrap && (direction == GWDGalleryConstants.Direction.FORWARDS && newIndex < this.frameIndex_ || direction == GWDGalleryConstants.Direction.BACKWARDS && newIndex > this.frameIndex_) || this.goToFrame(newIndex + 1, animate);
  }
};
GWDGalleryElementImpl.prototype.goBackwards = function(opt_animate, opt_wrap) {
  return this.goBackwardsForwardsImpl_(GWDGalleryConstants.Direction.BACKWARDS, opt_animate, opt_wrap);
};
GWDGalleryElementImpl.prototype.goForwards = function(opt_animate, opt_wrap) {
  return this.goBackwardsForwardsImpl_(GWDGalleryConstants.Direction.FORWARDS, opt_animate, opt_wrap);
};
GWDGalleryElementImpl.prototype.rotateOnce = function(opt_duration, opt_direction) {
  var duration = opt_duration || 0;
  this.autoplayer_.play(duration, opt_direction);
};
GWDGalleryElementImpl.prototype.stopRotation = function() {
  this.autoplayer_.stop();
};
GWDGalleryElementImpl.prototype.getCurrentIndex_ = function() {
  return 0 < this.frameCount_ ? this.frameIndex_ + 1 : void 0;
};
GWDGalleryElementImpl.prototype.getFrameSnapInterval_ = function() {
  return this.frameSnapInterval_;
};
GWDGalleryElementImpl.prototype.getFrameCount_ = function() {
  return this.frameCount_;
};
var GwdGalleryNavigationConstants = {BUTTON_FRAME_NUM_PROPERTY:"gwdTargetFrameNum", GRAY_PLACEHOLDER_THUMBNAIL_GIF:"data:image/gif;base64,R0lGODlhAQABAPAAAGZmZgAAACH5BAAAAAAALAAAAAABAAEAAAICRAEAOw==", TAG_NAME:"gwd-gallerynavigation", GROUP_REFERENCE_ATTR:"data-gwd-group", GROUP_ID_ATTR:"data-gwd-grp-id", Attributes:{FOR:"for", HIGHLIGHT:"highlight", USE_THUMBNAILS:"use-thumbnails"}, StyleClasses:{ACTIVE:"active", BUTTON:"button", BUTTON_CONTAINER:"button-container", FRAME_DOT:"frame-dot", FRAME_THUMBNAIL:"frame-thumbnail"}};
var GwdDoubleClickConstants = {EVENT_DETAIL_URL:"url", EXPANDED_PAGE:"data-gwd-expanded", FULLSCREEN_CLASS_NAME:"fs", GWD_DATABINDER:"gwd-data-binder", GWD_YOUTUBE:"gwd-youtube", HANDLED:"handled", HTML_AUDIO:"audio", HTML_VIDEO:"video", START_PAGE_TRANSITION_DELAY:30, TAG_NAME:"gwd-doubleclick", Attributes:{DATA_PROVIDER:"data-provider", FULLSCREEN:"fullscreen", POLITE_LOAD:"polite-load"}, Events:{AD_INITIALIZED:"adinitialized", COLLAPSE_FINISH:"collapsefinish", COLLAPSE_START:"collapsestart", EXPAND_FINISH:"expandfinish", 
EXPAND_START:"expandstart", FULLSCREEN_SUPPORT:"fullscreensupport"}};
var BrowserUtil = {Orientation:{PORTRAIT:1, LANDSCAPE:2}, getUserAgentString_:function() {
  return window.navigator.userAgent || "";
}, isWebKit:function() {
  return -1 != BrowserUtil.getUserAgentString_().indexOf("WebKit");
}, isAndroid:function() {
  return -1 != BrowserUtil.getUserAgentString_().indexOf("Android");
}, isFirefox:function() {
  var userAgent = BrowserUtil.getUserAgentString_();
  return -1 != userAgent.indexOf("rv:") && -1 != userAgent.indexOf("Gecko");
}, isIE:function() {
  var userAgent = BrowserUtil.getUserAgentString_();
  return -1 < userAgent.indexOf("Trident") || -1 < userAgent.indexOf("MSIE");
}, isGwdDoubleClick_:function(element) {
  return element.tagName.toLowerCase() == GwdDoubleClickConstants.TAG_NAME;
}, openUrl:function(url) {
  window.open(url);
}, getOrientation:function() {
  return BrowserUtil.isPortrait_() ? BrowserUtil.Orientation.PORTRAIT : BrowserUtil.Orientation.LANDSCAPE;
}, isPortrait_:function() {
  return window.innerHeight >= window.innerWidth;
}, getQueryString:function() {
  return window.location.search;
}, setQueryString:function(queryString) {
  window.location.search = queryString;
}};
var GWDSwipeGalleryElementImpl = function() {
};
goog.inherits(GWDSwipeGalleryElementImpl, GWDGalleryElementImpl);
GWDSwipeGalleryElementImpl.prototype.createdCallback = function() {
  GWDSwipeGalleryElementImpl.superClass_.createdCallback.call(this);
  var imagesAttr = GwdSwipeGalleryConstants.Attributes.IMAGES;
  this.loaded_ = !1;
  this.matte_ = this.container_ = null;
  if (this.framesFromImages_ = this.hasAttribute(imagesAttr)) {
    for (;this.firstChild;) {
      this.removeChild(this.firstChild);
    }
  }
  this.currentStripTranslation_ = GwdSwipeGalleryUtil.createVector(0);
  this.gesture_ = GalleryUtil.createGestureElement();
  this.gestureDisabled_ = !1;
  this.mouseOnFrameIndex_ = null;
  this.outGestureHandler_ = this.onOutGesture_.bind(this);
  this.overGestureHandler_ = this.onOverGesture_.bind(this);
  this.moveGestureHandler_ = this.onMoveGesture_.bind(this);
  this.outContainerHandler_ = this.onOutContainer_.bind(this);
  this.overContainerHandler_ = this.onOverContainer_.bind(this);
  this.clickContainerHandler_ = this.onClickContainer_.bind(this);
  this.trackHandler_ = this.onTrack_.bind(this);
  this.trackEndHandler_ = this.onTrackEnd_.bind(this);
  this.tapHandler_ = this.onTap_.bind(this);
  this.frameTapHandler_ = this.onFrameTap_.bind(this);
  this.pageLoadHandler_ = this.onFramesLoad_.bind(this);
  this.firstInteractionHandler_ = EventUtil.dispatch.bind(null, GWDGalleryConstants.Events.FIRST_INTERACTION, this);
  this.animating_ = !1;
  this.pendingEvents_ = [];
  this.transitionEndHandler_ = GalleryUtil.dispatchEventsOnTransitionEnd.bind(null, this, this.pendingEvents_);
  this.swipeCommittedThreshold_ = this.swipeThreshold_ = this.animationSpeed_ = this.autoplayStepInterval_ = this.autoplayDuration_ = 0;
  this.fullFramesVisible_ = 1;
  this.displayedFrames_ = [];
  this.framesToShow_ = 0;
  this.oobElasticityFactor_ = .7;
  this.perFrameOffset_ = 0;
  this.suppressingTracking_ = !1;
  this.padding_ = GwdSwipeGalleryUtil.createVector(0);
  this.frameDimension_ = GwdSwipeGalleryUtil.createVector(0);
  this.navigationEl_ = null;
  this.numFramesToDisplay_ = this.lastActivatedIndex_ = -1;
  this.exitUrls_ = [];
  this.frameSizeSetting_ = GwdSwipeGalleryUtil.createVector(GwdSwipeGalleryConstants.Defaults.FRAME_WIDTH, GwdSwipeGalleryConstants.Defaults.FRAME_HEIGHT);
  var swipeY = this.getAttribute(GwdSwipeGalleryConstants.Attributes.SWIPE_AXIS) == GwdSwipeGalleryConstants.SWIPE_Y;
  this.swipeAxis_ = GwdSwipeGalleryUtil.createVector(swipeY ? 0 : 1, swipeY ? 1 : 0);
  Object.defineProperty(this, "firstVisibleFrameIndex", {enumerable:!0, get:this.getFirstVisibleFrameIndex_.bind(this)});
  Object.defineProperty(this, "lastVisibleFrameIndex", {enumerable:!0, get:this.getLastVisibleFrameIndex_.bind(this)});
};
GWDSwipeGalleryElementImpl.prototype.attachedCallback = function() {
  var gesture = this.gesture_;
  gesture.addEventListener(EventTypes.POINTER_OVER, this.overGestureHandler_, !1);
  gesture.addEventListener(EventTypes.POINTER_OUT, this.outGestureHandler_, !1);
  gesture.addEventListener(EventTypes.POINTER_MOVE, this.moveGestureHandler_, !1);
  gesture.addEventListener(EventTypes.TRACK, this.trackHandler_, !1);
  gesture.addEventListener(EventTypes.TRACK_END, this.trackEndHandler_, !1);
  gesture.addEventListener(EventTypes.TAP, this.tapHandler_, !1);
  this.addEventListener(GWDGalleryConstants.Events.FRAME_TAP, this.frameTapHandler_, !1);
  this.addEventListener(EventTypes.TRANSITION_END, this.transitionEndHandler_, !1);
  this.addEventListener(EventTypes.WEBKIT_TRANSITION_END, this.transitionEndHandler_, !1);
  DomUtil.maybeLoadElement(this);
};
GWDSwipeGalleryElementImpl.prototype.detachedCallback = function() {
  var gesture = this.gesture_;
  gesture.removeEventListener(EventTypes.POINTER_OVER, this.overGestureHandler_, !1);
  gesture.removeEventListener(EventTypes.POINTER_OUT, this.outGestureHandler_, !1);
  gesture.removeEventListener(EventTypes.POINTER_MOVE, this.moveGestureHandler_, !1);
  gesture.removeEventListener(EventTypes.TRACK, this.trackHandler_, !1);
  gesture.removeEventListener(EventTypes.TRACK_END, this.trackEndHandler_, !1);
  gesture.removeEventListener(EventTypes.TAP, this.tapHandler_, !1);
  this.removeEventListener(GWDGalleryConstants.Events.FRAME_TAP, this.frameTapHandler_, !1);
  this.removeEventListener(EventTypes.TRANSITION_END, this.transitionEndHandler_);
  this.removeEventListener(EventTypes.WEBKIT_TRANSITION_END, this.transitionEndHandler_);
};
GWDSwipeGalleryElementImpl.prototype.attributeChangedCallback = function(attributeName) {
  switch(attributeName) {
    case GwdSwipeGalleryConstants.Attributes.IMAGES:
      this.frames_ = GalleryUtil.createFrames(this.getAttribute(GwdSwipeGalleryConstants.Attributes.IMAGES));
      this.loadFrames_();
      this.styleAndStart_();
      break;
    case GwdSwipeGalleryConstants.Attributes.SCALING:
      GalleryUtil.applyScaling(this.frames_, this.getAttribute(GwdSwipeGalleryConstants.Attributes.SCALING));
      break;
    case GwdSwipeGalleryConstants.Attributes.HAS_NAVIGATION:
    ;
    case GwdSwipeGalleryConstants.Attributes.NAVIGATION_HIGHLIGHT:
    ;
    case GwdSwipeGalleryConstants.Attributes.NAVIGATION_THUMBNAILS:
      this.updateNavigationElement_();
      this.styleAndStart_();
      break;
    case GwdSwipeGalleryConstants.Attributes.TRANSITION_DURATION:
    ;
    case GwdSwipeGalleryConstants.Attributes.EXIT_URLS:
    ;
    case GwdSwipeGalleryConstants.Attributes.AUTOPLAY_DURATION:
    ;
    case GwdSwipeGalleryConstants.Attributes.AUTOPLAY_STEP_INTERVAL:
      this.updateSettings_();
      break;
    case GwdSwipeGalleryConstants.Attributes.FRAME_WIDTH:
    ;
    case GwdSwipeGalleryConstants.Attributes.FRAME_HEIGHT:
    ;
    case GwdSwipeGalleryConstants.Attributes.FRAME_SNAP_INTERVAL:
    ;
    case GwdSwipeGalleryConstants.Attributes.NUM_FRAMES_TO_DISPLAY:
      this.updateSettings_();
      this.styleAndStart_();
      break;
    case GwdSwipeGalleryConstants.Attributes.DISABLE_GESTURE:
    ;
    case GwdSwipeGalleryConstants.Attributes.FRAME_OFFSET:
    ;
    case GwdSwipeGalleryConstants.Attributes.START_FRAME:
    ;
    case GwdSwipeGalleryConstants.Attributes.SWIPE_THRESHOLD_RATIO:
    ;
    case GwdSwipeGalleryConstants.Attributes.SWIPE_COMMITTED_THRESHOLD_RATIO:
      this.styleAndStart_();
  }
};
GWDSwipeGalleryElementImpl.prototype.updateSettings_ = function() {
  var numFramesToDisplay = DomUtil.getIntegerAttribute(this, GwdSwipeGalleryConstants.Attributes.NUM_FRAMES_TO_DISPLAY, GwdSwipeGalleryConstants.Defaults.NUM_FRAMES_TO_DISPLAY), frameSnapInterval = DomUtil.getIntegerAttribute(this, GwdSwipeGalleryConstants.Attributes.FRAME_SNAP_INTERVAL, GwdSwipeGalleryConstants.Defaults.FRAME_SNAP_INTERVAL), animationSpeed = DomUtil.getIntegerAttribute(this, GwdSwipeGalleryConstants.Attributes.TRANSITION_DURATION, GwdSwipeGalleryConstants.Defaults.TRANSITION_DURATION), 
  frameWidthSetting = DomUtil.getIntegerAttribute(this, GwdSwipeGalleryConstants.Attributes.FRAME_WIDTH, GwdSwipeGalleryConstants.Defaults.FRAME_WIDTH), frameHeightSetting = DomUtil.getIntegerAttribute(this, GwdSwipeGalleryConstants.Attributes.FRAME_HEIGHT, GwdSwipeGalleryConstants.Defaults.FRAME_HEIGHT), commaDelimitedExitUrls = DomUtil.getStringAttribute(this, GwdSwipeGalleryConstants.Attributes.EXIT_URLS, ""), autoplayDuration = DomUtil.getFloatAttribute(this, GwdSwipeGalleryConstants.Attributes.AUTOPLAY_DURATION, 
  GwdSwipeGalleryConstants.Defaults.AUTOPLAY_DURATION), autoplayStepInterval = DomUtil.getFloatAttribute(this, GwdSwipeGalleryConstants.Attributes.AUTOPLAY_STEP_INTERVAL, GwdSwipeGalleryConstants.Defaults.AUTOPLAY_STEP_INTERVAL);
  DebugUtil.assert(-1 == numFramesToDisplay || 1 <= numFramesToDisplay);
  DebugUtil.assert(1 <= frameSnapInterval);
  DebugUtil.assert(0 <= animationSpeed);
  DebugUtil.assert(-1 == frameWidthSetting || 0 < frameWidthSetting);
  DebugUtil.assert(-1 == frameHeightSetting || 0 < frameHeightSetting);
  DebugUtil.assert(0 < autoplayDuration);
  DebugUtil.assert(0 <= autoplayStepInterval);
  this.frameSizeSetting_.x = frameWidthSetting;
  this.frameSizeSetting_.y = frameHeightSetting;
  -1 != GwdSwipeGalleryUtil.dotProduct(this.frameSizeSetting_, this.swipeAxis_) ? numFramesToDisplay = -1 : 0 < numFramesToDisplay && frameSnapInterval > numFramesToDisplay && (frameSnapInterval = numFramesToDisplay);
  this.exitUrls_ = commaDelimitedExitUrls.split(/,/g);
  this.numFramesToDisplay_ = numFramesToDisplay;
  this.frameSnapInterval_ = frameSnapInterval;
  this.animationSpeed_ = animationSpeed;
  this.autoplayDuration_ = autoplayDuration;
  this.autoplayStepInterval_ = autoplayStepInterval;
};
GWDSwipeGalleryElementImpl.prototype.styleAndStart_ = function() {
  var elementWidth = this.clientWidth, elementHeight = this.clientHeight, elementSize = GwdSwipeGalleryUtil.createVector(elementWidth, elementHeight);
  this.navigationEl_ && (elementSize.y -= GwdSwipeGalleryConstants.NAV_SPACE_PX, this.matte_.style.height = elementSize.y + "px");
  var swipeAxis = this.swipeAxis_, frameMargin = GwdSwipeGalleryUtil.copyAndScale(swipeAxis, DomUtil.getIntegerAttribute(this, GwdSwipeGalleryConstants.Attributes.FRAME_OFFSET, GwdSwipeGalleryConstants.Defaults.FRAME_OFFSET)), swipeThresholdRatio = DomUtil.getFloatAttribute(this, GwdSwipeGalleryConstants.Attributes.SWIPE_THRESHOLD_RATIO, GwdSwipeGalleryConstants.Defaults.SWIPE_THRESHOLD_RATIO), swipeCommittedThresholdRatio = DomUtil.getFloatAttribute(this, GwdSwipeGalleryConstants.Attributes.SWIPE_COMMITTED_THRESHOLD_RATIO, 
  GwdSwipeGalleryConstants.Defaults.SWIPE_COMMITTED_THRESHOLD_RATIO), frame = GwdSwipeGalleryUtil.determineFrameSize(swipeAxis, elementSize, this.numFramesToDisplay_, this.frameSizeSetting_, frameMargin), defaultStartFrame = 2 < this.numFramesToDisplay_ ? 1 + Math.ceil(this.numFramesToDisplay_ / 2 - 1) : 1, startFrame = DomUtil.getIntegerAttribute(this, GwdSwipeGalleryConstants.Attributes.START_FRAME, defaultStartFrame), gestureDisabled = this.hasAttribute(GwdSwipeGalleryConstants.Attributes.DISABLE_GESTURE), 
  perFrameOffset = GwdSwipeGalleryUtil.determinePerFrameOffset(swipeAxis, frame, frameMargin), fullFramesVisible = GwdSwipeGalleryUtil.determineFullFrameVisible(swipeAxis, elementSize, frame, perFrameOffset), padding = GwdSwipeGalleryUtil.createVector((elementSize.x - frame.x) / 2, (elementSize.y - frame.y) / 2);
  if (0 < this.numFramesToDisplay_ && 0 == this.numFramesToDisplay_ % 2) {
    var delta = GwdSwipeGalleryUtil.project(GwdSwipeGalleryUtil.createVector(frame.x + frameMargin.x, frame.y + frameMargin.y), swipeAxis);
    padding.x -= .5 * delta.x;
    padding.y -= .5 * delta.y;
    fullFramesVisible += 1;
  }
  DebugUtil.assert(0 < swipeThresholdRatio);
  DebugUtil.assert(0 < swipeCommittedThresholdRatio);
  DebugUtil.assert(1 <= startFrame);
  this.frameDimension_ = frame;
  this.padding_ = padding;
  this.fullFramesVisible_ = fullFramesVisible;
  this.perFrameOffset_ = GwdSwipeGalleryUtil.dotProduct(perFrameOffset, this.swipeAxis_);
  this.gestureDisabled_ = gestureDisabled;
  this.swipeThreshold_ = GwdSwipeGalleryUtil.dotProduct(frame, swipeAxis) * swipeThresholdRatio;
  this.swipeCommittedThreshold_ = GwdSwipeGalleryUtil.dotProduct(frame, swipeAxis) * swipeCommittedThresholdRatio;
  for (var current = GwdSwipeGalleryUtil.project(padding, GwdSwipeGalleryUtil.createVector(swipeAxis.y, swipeAxis.x)), frameStyle, i = 0;i < this.frameCount_;i++) {
    frameStyle = this.frames_[i].style, frameStyle.left = current.x + "px", frameStyle.top = current.y + "px", frameStyle.width = frame.x + "px", frameStyle.height = frame.y + "px", current.x += perFrameOffset.x, current.y += perFrameOffset.y;
  }
  this.currentStripTranslation_ = GwdSwipeGalleryUtil.createVector(0);
  if (this.container_) {
    this.animate_(0, 0, 0);
    var projectedPadding = GwdSwipeGalleryUtil.project(padding, swipeAxis);
    this.container_.style.left = projectedPadding.x + "px";
    this.container_.style.top = projectedPadding.y + "px";
  }
  this.frameIndex_ = null;
  this.goToFrame(startFrame, GWDGalleryConstants.Animate.NONE);
};
GWDSwipeGalleryElementImpl.prototype.gwdIsLoaded = function() {
  return this.loaded_;
};
GWDSwipeGalleryElementImpl.prototype.gwdLoad = function() {
  this.loaded_ || this.container_ ? DebugUtil.log("Unexpected unnecessary call to swipe gallery gwdLoad()") : (this.frames_ = this.framesFromImages_ ? GalleryUtil.createFrames(this.getAttribute(GwdSwipeGalleryConstants.Attributes.IMAGES)) : GalleryUtil.extractFrames(this.childNodes), this.loadFrames_());
};
GWDSwipeGalleryElementImpl.prototype.goBackwards = function(opt_animate, opt_wrap) {
  var wrap = null != opt_wrap ? opt_wrap : !1;
  return GWDSwipeGalleryElementImpl.superClass_.goBackwards.call(this, opt_animate, wrap);
};
GWDSwipeGalleryElementImpl.prototype.goForwards = function(opt_animate, opt_wrap) {
  var wrap = null != opt_wrap ? opt_wrap : !1;
  return GWDSwipeGalleryElementImpl.superClass_.goForwards.call(this, opt_animate, wrap);
};
GWDSwipeGalleryElementImpl.prototype.goToFrameImpl_ = function(targetFrameNumber, opt_animate) {
  var targetFrameIndex = targetFrameNumber - 1, targetFrameIndex = targetFrameIndex - targetFrameIndex % this.frameSnapInterval_, targetFrameIndex = targetFrameIndex + Math.floor((this.frameSnapInterval_ - 1) / 2);
  targetFrameIndex >= this.frameCount_ && (targetFrameIndex = this.frameCount_ - 1);
  var previousFrameIndex = this.frameIndex_;
  this.frameIndex_ = targetFrameIndex;
  var translation = GwdSwipeGalleryUtil.copyAndScale(this.swipeAxis_, -this.perFrameOffset_ * this.frameIndex_), shouldAnimate = opt_animate != GWDGalleryConstants.Animate.NONE;
  this.animate_(shouldAnimate ? this.animationSpeed_ : 0, translation.x, translation.y);
  this.currentStripTranslation_ = translation;
  this.markViewedFrames_();
  previousFrameIndex != this.frameIndex_ && (this.maybeActivateFrame_(this.frameIndex_ + 1), this.pendingEvents_.push(GWDGalleryConstants.Events.FRAME_SHOWN));
  this.animating_ || this.transitionEndHandler_();
};
GWDSwipeGalleryElementImpl.prototype.markViewedFrames_ = function() {
  if (this.framesToShow_) {
    for (var fullFramesLeftOfCurrent = Math.floor((this.fullFramesVisible_ - 1) / 2), n = 0;n < this.fullFramesVisible_;n++) {
      var visibleFrameIndex = this.frameIndex_ - fullFramesLeftOfCurrent + n;
      if (!(0 > visibleFrameIndex || visibleFrameIndex >= this.frameCount_ || this.displayedFrames_[visibleFrameIndex] || (this.displayedFrames_[visibleFrameIndex] = !0, --this.framesToShow_))) {
        this.pendingEvents_.push(GWDGalleryConstants.Events.ALL_FRAMES_VIEWED);
        break;
      }
    }
  }
};
GWDSwipeGalleryElementImpl.prototype.animate_ = function(duration, x, y) {
  this.animating_ = 0 < duration;
  CssUtil.applyCssWithBrowserPrefix(this.container_, "transition", "all " + duration + "ms");
  CssUtil.applyCssWithBrowserPrefix(this.container_, "transform", "translate3d(" + x + "px," + y + "px,0)");
};
GWDSwipeGalleryElementImpl.prototype.loadFrames_ = function() {
  for (;this.firstChild;) {
    this.removeChild(this.firstChild);
  }
  this.navigationEl_ = null;
  this.container_ && (this.container_.removeEventListener(EventTypes.PAGE_LOAD, this.pageLoadHandler_, !1), this.container_.removeEventListener(EventTypes.MOUSE_OVER, this.overContainerHandler_, !0), this.container_.removeEventListener(EventTypes.MOUSE_OUT, this.outContainerHandler_, !0), this.container_.removeEventListener(EventTypes.CLICK, this.clickContainerHandler_, !0));
  var container = GalleryUtil.createLoadingPage(this.frames_);
  this.container_ = container;
  container.className = "container";
  this.container_.addEventListener(EventTypes.PAGE_LOAD, this.pageLoadHandler_, !1);
  this.container_.addEventListener(EventTypes.MOUSE_OVER, this.overContainerHandler_, !0);
  this.container_.addEventListener(EventTypes.MOUSE_OUT, this.outContainerHandler_, !0);
  this.container_.addEventListener(EventTypes.CLICK, this.clickContainerHandler_, !0);
  GalleryUtil.applyScaling(this.frames_, this.getAttribute(GwdSwipeGalleryConstants.Attributes.SCALING));
  this.frameCount_ = this.frames_.length;
  var matte = document.createElement("div");
  this.matte_ = matte;
  matte.className = GwdSwipeGalleryConstants.ClassName.MATTE;
  matte.appendChild(container);
  this.appendChild(this.matte_);
  this.appendChild(this.gesture_);
};
GWDSwipeGalleryElementImpl.prototype.onFramesLoad_ = function(event) {
  if (event.target === this.container_) {
    this.loaded_ = !0;
    this.framesToShow_ = this.frameCount_;
    this.displayedFrames_ = [];
    this.updateSettings_();
    this.updateNavigationElement_();
    this.styleAndStart_();
    var eventName = GWDGalleryConstants.Events.ALL_FRAMES_LOADED;
    EventUtil.dispatch(eventName, this);
    this.hasAttribute(GwdSwipeGalleryConstants.Attributes.AUTOPLAY) && this.autoplayer_.play(this.autoplayDuration_, GWDGalleryConstants.Direction.FORWARDS, this.autoplayStepInterval_);
    EventUtil.dispatch(EventTypes.READY, this);
  }
};
GWDSwipeGalleryElementImpl.prototype.rotateOnce = function(opt_duration, opt_direction) {
  var duration = opt_duration || this.animationSpeed_;
  this.autoplayer_.play(duration, opt_direction);
};
GWDSwipeGalleryElementImpl.prototype.indicateCurrentSwipe_ = function(displacement) {
  if (0 < displacement && 0 === this.frameIndex_ || 0 > displacement && this.frameIndex_ === this.frameCount_ - 1) {
    displacement -= displacement * this.oobElasticityFactor_;
  }
  this.animate_(0, this.currentStripTranslation_.x + this.swipeAxis_.x * displacement, this.currentStripTranslation_.y + this.swipeAxis_.y * displacement);
};
GWDSwipeGalleryElementImpl.prototype.completeCommittedMove_ = function(displacement) {
  var frameCount = this.frameCount_;
  if (frameCount) {
    var oldFrameIndex = this.frameIndex_, newFrameIndex = this.getNewFrameIndex_(displacement);
    this.goToFrame(newFrameIndex + 1);
    oldFrameIndex != newFrameIndex && (0 == newFrameIndex ? EventUtil.dispatch(GWDGalleryConstants.Events.REACH_LEFT_END, this) : newFrameIndex == frameCount - 1 && EventUtil.dispatch(GWDGalleryConstants.Events.REACH_RIGHT_END, this));
  }
};
GWDSwipeGalleryElementImpl.prototype.updateNavigationElement_ = function() {
  var shouldHaveNavigation = this.hasAttribute(GwdSwipeGalleryConstants.Attributes.HAS_NAVIGATION), hasHadNavigation = !!this.navigationEl_;
  if (shouldHaveNavigation && !hasHadNavigation) {
    var id = this.id || this.getAttribute(GwdGalleryNavigationConstants.GROUP_ID_ATTR);
    this.navigationEl_ = document.createElement(GwdGalleryNavigationConstants.TAG_NAME);
    this.navigationEl_.setAttribute(GwdGalleryNavigationConstants.Attributes.FOR, id);
    this.classList.add(GwdSwipeGalleryConstants.ClassName.HAS_NAVIGATION);
    this.appendChild(this.navigationEl_);
  } else {
    !shouldHaveNavigation && hasHadNavigation && (this.classList.remove(GwdSwipeGalleryConstants.ClassName.HAS_NAVIGATION), this.removeChild(this.navigationEl_), this.navigationEl_ = null);
  }
  this.navigationEl_ && (DomUtil.copyAttribute(this, GwdSwipeGalleryConstants.Attributes.NAVIGATION_HIGHLIGHT, this.navigationEl_, GwdGalleryNavigationConstants.Attributes.HIGHLIGHT), DomUtil.copyAttribute(this, GwdSwipeGalleryConstants.Attributes.NAVIGATION_THUMBNAILS, this.navigationEl_, GwdGalleryNavigationConstants.Attributes.USE_THUMBNAILS));
};
GWDSwipeGalleryElementImpl.prototype.getNewFrameIndex_ = function(displacement) {
  var newFrameIndex = this.frameIndex_;
  Math.abs(displacement) > this.swipeThreshold_ && (newFrameIndex = 0 > displacement ? newFrameIndex + this.frameSnapInterval_ : newFrameIndex - this.frameSnapInterval_);
  0 > newFrameIndex ? newFrameIndex = 0 : newFrameIndex >= this.frameCount_ && (newFrameIndex = this.frameCount_ - 1);
  return newFrameIndex;
};
GWDSwipeGalleryElementImpl.prototype.maybeActivateFrame_ = function(index) {
  this.lastActivatedIndex_ != index && (this.lastActivatedIndex_ = index, GalleryUtil.dispatchEventWithIndex(this, GWDGalleryConstants.Events.FRAME_ACTIVATED, index));
};
GWDSwipeGalleryElementImpl.prototype.onTrack_ = function(event) {
  if (!this.gestureDisabled_ && (this.firstInteractionHandler_ && (this.firstInteractionHandler_(), this.firstInteractionHandler_ = null), !this.suppressingTracking_)) {
    this.stopRotation();
    var displacement = GwdSwipeGalleryUtil.dotProduct(GwdSwipeGalleryUtil.createVector(event.dx, event.dy), this.swipeAxis_);
    this.maybeActivateFrame_(this.getNewFrameIndex_(displacement) + 1);
    Math.abs(displacement) > this.swipeCommittedThreshold_ ? (this.completeCommittedMove_(displacement), this.suppressingTracking_ = !0) : this.indicateCurrentSwipe_(displacement);
  }
};
GWDSwipeGalleryElementImpl.prototype.onTrackEnd_ = function(event) {
  this.gestureDisabled_ || (this.suppressingTracking_ ? this.suppressingTracking_ = !1 : this.completeCommittedMove_(GwdSwipeGalleryUtil.dotProduct(GwdSwipeGalleryUtil.createVector(event.dx, event.dy), this.swipeAxis_)));
};
GWDSwipeGalleryElementImpl.prototype.getFrameIndexForGestureMouseEvent_ = function(event) {
  var clientBounds = this.getBoundingClientRect(), offsetX = event.clientX - clientBounds.left, offsetY = event.clientY - clientBounds.top, offset = GwdSwipeGalleryUtil.createVector(offsetX, offsetY);
  if (GwdSwipeGalleryUtil.isTapOutsideOfFrame(this.swipeAxis_, offset, this.padding_, this.frameDimension_)) {
    return null;
  }
  var x = GwdSwipeGalleryUtil.determineGalleryOffset(this.swipeAxis_, offset, this.currentStripTranslation_, this.padding_), index = Math.floor(x / this.perFrameOffset_), location = x % this.perFrameOffset_;
  return 0 > index || index >= this.frameCount_ || location > GwdSwipeGalleryUtil.dotProduct(this.swipeAxis_, this.frameDimension_) ? null : index;
};
GWDSwipeGalleryElementImpl.prototype.onTap_ = function(event) {
  if (!this.gestureDisabled_) {
    this.stopRotation();
    var index = this.getFrameIndexForGestureMouseEvent_(event);
    null != index && EventUtil.dispatch(GWDGalleryConstants.Events.FRAME_TAP, this, {element:this.frames_[index], id:index + 1});
  }
};
GWDSwipeGalleryElementImpl.prototype.onFrameTap_ = function(event) {
  var oneBasedIndex = event.detail && event.detail.id;
  if (oneBasedIndex) {
    var index = oneBasedIndex - 1, exitUrl = this.exitUrls_[index];
    if (exitUrl) {
      var exitEvent = EventUtil.dispatch(GWDGalleryConstants.Events.FRAME_EXIT, this, {url:exitUrl});
      exitEvent.detail[GwdDoubleClickConstants.HANDLED] || BrowserUtil.openUrl(exitUrl);
    }
  }
};
GWDSwipeGalleryElementImpl.prototype.onOutGesture_ = function() {
  this.gestureDisabled_ || null == this.mouseOnFrameIndex_ || (EventUtil.dispatch(GWDGalleryConstants.Events.FRAME_MOUSE_OUT, this, {element:this.frames_[this.mouseOnFrameIndex_], id:1 + this.mouseOnFrameIndex_}), this.mouseOnFrameIndex_ = null);
};
GWDSwipeGalleryElementImpl.prototype.onOverGesture_ = function(event) {
  if (!this.gestureDisabled_) {
    var newIndex = this.getFrameIndexForGestureMouseEvent_(event);
    newIndex != this.mouseOnFrameIndex_ && (null != this.mouseOnFrameIndex_ && EventUtil.dispatch(GWDGalleryConstants.Events.FRAME_MOUSE_OUT, this, {element:this.frames_[this.mouseOnFrameIndex_], id:1 + this.mouseOnFrameIndex_}), null != newIndex && EventUtil.dispatch(GWDGalleryConstants.Events.FRAME_MOUSE_OVER, this, {element:this.frames_[newIndex], id:1 + newIndex}), this.mouseOnFrameIndex_ = newIndex);
  }
};
GWDSwipeGalleryElementImpl.prototype.onMoveGesture_ = function(event) {
  if (!this.gestureDisabled_) {
    var newIndex = this.getFrameIndexForGestureMouseEvent_(event);
    newIndex != this.mouseOnFrameIndex_ && (null != this.mouseOnFrameIndex_ && EventUtil.dispatch(GWDGalleryConstants.Events.FRAME_MOUSE_OUT, this, {element:this.frames_[this.mouseOnFrameIndex_], id:1 + this.mouseOnFrameIndex_}), null != newIndex && EventUtil.dispatch(GWDGalleryConstants.Events.FRAME_MOUSE_OVER, this, {element:this.frames_[newIndex], id:1 + newIndex}), this.mouseOnFrameIndex_ = newIndex);
  }
};
GWDSwipeGalleryElementImpl.prototype.onOverContainer_ = function(event) {
  this.gestureDisabled_ && event.target.classList.contains(GalleryUtil.FRAME_CLASS_NAME_) && EventUtil.dispatch(GWDGalleryConstants.Events.FRAME_MOUSE_OVER, this, {element:event.target, id:1 + this.frames_.indexOf(event.target)});
};
GWDSwipeGalleryElementImpl.prototype.onOutContainer_ = function(event) {
  this.gestureDisabled_ && event.target.classList.contains(GalleryUtil.FRAME_CLASS_NAME_) && EventUtil.dispatch(GWDGalleryConstants.Events.FRAME_MOUSE_OUT, this, {element:event.target, id:1 + this.frames_.indexOf(event.target)});
};
GWDSwipeGalleryElementImpl.prototype.onClickContainer_ = function(event) {
  this.gestureDisabled_ && event.target.classList.contains(GalleryUtil.FRAME_CLASS_NAME_) && EventUtil.dispatch(GWDGalleryConstants.Events.FRAME_TAP, this, {element:event.target, id:1 + this.frames_.indexOf(event.target)});
};
GWDSwipeGalleryElementImpl.prototype.getUnboundedFirstVisibleFrameIndex = function() {
  DebugUtil.assert(0 < this.numFramesToDisplay_ && 0 < this.frameCount_);
  var framesLeftOfCenter = Math.floor((this.numFramesToDisplay_ - 1) / 2);
  return 1 + this.frameIndex_ - framesLeftOfCenter;
};
GWDSwipeGalleryElementImpl.prototype.getFirstVisibleFrameIndex_ = function() {
  if (0 < this.numFramesToDisplay_ && 0 < this.frameCount_) {
    return Math.max(1, this.getUnboundedFirstVisibleFrameIndex());
  }
};
GWDSwipeGalleryElementImpl.prototype.getLastVisibleFrameIndex_ = function() {
  if (0 < this.numFramesToDisplay_ && 0 < this.frameCount_) {
    return Math.min(this.frameCount_, this.getUnboundedFirstVisibleFrameIndex() + this.numFramesToDisplay_ - 1);
  }
};
document.registerElement(GwdSwipeGalleryConstants.TAG_NAME, {prototype:GWDSwipeGalleryElementImpl.prototype});
}()
